`include "time_scale.v"
`include "i8051_lib.v"
module DO_DA (
    a ,
    c1,
    c2,
    r ,
    cy 
  );
  input  [7:0] a;
  input        c1, c2;
  output [7:0] r;
  output       cy;
  
  wire [8:0] v1, v2, v3, v4;
  wire       v8;
  assign v1 = {1'b0, a};
  assign v2 = v1 + 9'b0_0000_0110;
  assign v8 = v2[8] | c1;
  assign v3 = v2 + 9'b0_0110_0000;
  assign v4 = 
  ( v8  == 1'b1  || (v2[7:4] > `C9_4) ) ? v3 :
  ( (c2 == 1'b1) || (v1[3:0] > `C9_4) ) ? v2 : v1;

  assign r  = v4[7:0];
  assign cy = v4[8];
  
  
endmodule

